import { __decorate, __param } from 'tslib';
import { NgModule, ɵɵdefineInjectable, ɵɵinject, Injectable, Pipe, InjectionToken, Inject } from '@angular/core';
import { Router, RoutesRecognized, NavigationStart, NavigationError, NavigationCancel } from '@angular/router';
import { catchError, tap, map, retryWhen, zip, mergeMap, finalize, filter, switchMap, pairwise } from 'rxjs/operators';
import { Observable, of, range, throwError, timer, Subject, forkJoin } from 'rxjs';
import { NgProgress } from 'ngx-progressbar';
import { createFeatureSelector, select, Store, StoreModule } from '@ngrx/store';
import { getSelectors, routerReducer, StoreRouterConnectingModule } from '@ngrx/router-store';
import { CommonModule } from '@angular/common';
import { HttpClient } from '@angular/common/http';
import { Title } from '@angular/platform-browser';

class AuthContract {
}

class NotifyContract {
}

class SQLStoreContract {
}

class HttpStoreContract {
}

class KeyValueStoreContract {
}

class ConfigContract {
}

class EmitterContract {
    constructor() { }
}

/*
 * Public API Surface of services
 */

// usage: @delay()
function Delay(milliseconds = 0) {
    return function (target, key, descriptor) {
        var original = descriptor.value;
        descriptor.value = function (...args) {
            setTimeout(() => {
                original.apply(this, args);
            }, milliseconds);
        };
        return descriptor;
    };
}

// import { environment } from "../../environments/environment"
// usage @Log()
function Log(exceptions = [], isProduction = false) {
    return function (constructor) {
        if (!isProduction) {
            for (let prop in this) {
                const member = this[prop];
                if (!exceptions.includes(prop)) {
                    this[prop] = function (...args) {
                        console.log(`%c ${constructor.name} - ${prop}`, `color: #4CAF50; font-weight: bold`, ...args);
                        member && member.apply(this, args);
                    };
                }
            }
        }
    };
}

// usage @Sync()
function Sync(constructor) {
    return null;
    // const original = constructor.prototype.ngOnDestroy
    // constructor.prototype.ngOnDestroy = function () {
    //   for ( let prop in this ) {
    //     const property = this[ prop ]
    //     if ( property && (typeof property.unsubscribe === "function") ) {
    //       property.unsubscribe()
    //     }
    //   }
    //   original && typeof original === "function" && original.apply(this, arguments)
    // }
}

// usage: @Tick()
function Tick(milliseconds = 100) {
    return function (target, key, descriptor) {
        const original = descriptor.value;
        descriptor.value = function (...args) {
            setInterval(() => {
                original.apply(this, args);
            }, milliseconds);
        };
        return descriptor;
    };
}

// @Track('page name')
function Track(pageName) {
    return function (constructor) {
        // const analyticsService = AppModule.injector.get(AnalyticsService)
        const ngOnInit = constructor.prototype.ngOnInit;
        constructor.prototype.ngOnInit = function (...args) {
            // analyticsService.visit(pageName)
            ngOnInit && ngOnInit.apply(this, args);
        };
        const ngOnDestroy = constructor.prototype.ngOnDestroy;
        constructor.prototype.ngOnDestroy = function (...args) {
            // analyticsService.leave(pageName)
            ngOnDestroy && ngOnDestroy.apply(this, args);
        };
    };
}

// usage @Unsubscribe()
function Unsubscribe(exceptions = []) {
    return function (constructor) {
        const original = constructor.prototype.ngOnDestroy;
        constructor.prototype.ngOnDestroy = function () {
            for (let prop in this) {
                const property = this[prop];
                if (!exceptions.includes(prop)) {
                    if (property && (typeof property.unsubscribe === 'function')) {
                        property.unsubscribe();
                    }
                }
            }
            original && typeof original === 'function' && original.apply(this, arguments);
        };
    };
}

/*
 * Public API Surface of services
 */

let DirectivesModule = class DirectivesModule {
};
DirectivesModule = __decorate([
    NgModule({
        declarations: [],
        exports: []
    })
], DirectivesModule);

function time() {
    return new Date();
}
/**
 * set up a handle for injector
 * to be used to inject services without the contructor
 */
let injector;
function setInjector(anInjector) {
    if (injector) {
        console.error('Programming error: Injector was already set');
    }
    else {
        injector = anInjector;
    }
}
function outject(service) {
    return injector.get(service);
}
function keys(obj) {
    return Object.keys(obj);
}
function cut(oldStr, fullStr) {
    return fullStr.split(oldStr).join('');
}
function titleCase(words, seperator = ' ', joiner = ' ') {
    return words
        .split(seperator)
        .map((word) => {
        return word.charAt(0).toUpperCase() + word.slice(1).toLowerCase();
    })
        .join(joiner);
}
function camelCase(words, seperator = '_', joiner = '') {
    return words
        .split(seperator)
        .map((word, i) => {
        return i == 0
            ? word.toLowerCase()
            : word.charAt(0).toUpperCase() + word.slice(1).toLowerCase();
    })
        .join(joiner);
}
function merge(...objects) {
    return objects.reduce((prev, curr, index) => {
        return Object.assign(Object.assign({}, prev), curr);
    }, {});
}
function mergeToArray(...items) {
    return items.reduce((prev, curr, index) => {
        return [...prev, ...curr];
    }, []);
}
function hash(input) {
    return input ? input : Math.random().toString();
}
function plural(word) {
    return `${word}s`;
}
function singular(word) {
    return word;
}
function snakeCase(words, seperator = ' ', joiner = '_') {
    return (words
        // insert a space between lower & upper
        .replace(/([a-z])([A-Z])/g, '$1 $2')
        // space before last upper in a sequence followed by lower
        .replace(/\b([A-Z]+)([A-Z])([a-z])/, '$1 $2$3')
        // replace space with "_"
        .replace(/ +/g, '_')
        // lowercase everything
        .toLowerCase());
}
function isNumeric(str) {
    return !isNullOrUndefined(str) && /^\d+$/.test(str);
}
function isNullOrUndefined(value) {
    return value === undefined || value === null;
}
function isUndefined(value) {
    return value === undefined;
}
function isBlankString(value) {
    return value === '';
}
function isFunction(value) {
    return typeof value === 'function';
}
function isObject(x) {
    return x != null && typeof x === 'object';
}
function isArray(x) {
    return x != null && typeof x === 'object' && Array.isArray(x);
}
function toJSON(mayBeJSON, returnJSON = false) {
    try {
        let obj = JSON.parse(mayBeJSON);
        if (obj && typeof obj === 'object') {
            return returnJSON ? obj : true;
        }
    }
    catch (e) { }
    return false;
}
function compare(a, b, isAsc, type) {
    if (typeof a === 'string' && type === 'string') {
        return a.localeCompare(b) * (isAsc ? 1 : -1);
    }
    if (typeof a === 'number' && type === 'number') {
        return (a < b ? -1 : 1) * (isAsc ? 1 : -1);
    }
    if (typeof a === 'string' && type === 'time') {
        return ((new Date(a).getTime() < new Date(b).getTime() ? -1 : 1) *
            (isAsc ? 1 : -1));
    }
}
function routeGroupMatcher(haystack) {
    return (segments, segmentGroup, route) => {
        return segments.length === 1 &&
            haystack.includes(segments[0].path.toLowerCase())
            ? { consumed: segments }
            : null;
    };
}
function numberWithCommas(number) {
    if (isNullOrUndefined(number)) {
        return '0';
    }
    var parts = number.toString().split('.');
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    return parts.join('.');
}
// console.log(objectGroupBy(['one', 'two', 'three'], 'length'))
// => {3: ["one", "two"], 5: ["three"]}
// key can be a sort callback function
// todo: nice es6 typings function<TItem>(xs: TItem[], key: string) : {[key: string]: TItem[]} {
function objectGroupBy(input, key) {
    return input.reduce((prev, curr) => {
        var newKey = key instanceof Function
            ? key(curr)
            : curr[key]((prev[curr[newKey]] = prev[curr[newKey]] || [])).push(curr);
        return prev;
    }, {});
}
function arrayGroupBy(input, key) {
    if (isNullOrUndefined(input) || input.length < 1) {
        return [];
    }
    return input.reduce((prev, curr) => {
        if (isNullOrUndefined(curr) || curr.length < 1) {
            return prev;
        }
        let v = key instanceof Function ? key(curr) : curr[key];
        let el = prev.find((r) => r && r.key === v);
        if (el) {
            el.values.push(curr);
        }
        else {
            prev.push({ key: v, values: [curr] });
        }
        return prev;
    }, []);
}
function objectDeepMerge(input) {
    return input.reduce((prev, curr) => {
        for (const key in curr) {
            if (curr.hasOwnProperty(key)) {
                prev[key] = [...(prev[key] || []), curr[key]];
            }
        }
        return prev;
    }, {});
}
function randomString(length = 7) {
    length = 2 + length / 2;
    return (Math.random()
        .toString(36)
        .substring(2, length) +
        Math.random()
            .toString(36)
            .substring(2, length));
}
function isObservable(mayBeObservable) {
    return mayBeObservable instanceof Observable;
}
function copy(obj) {
    return JSON.parse(JSON.stringify(obj));
}
function deepCopy(input) {
    if (isArray(input)) {
        return input['map'](i => deepCopy(i));
    }
    else if (isObject(input)) {
        let output = {};
        for (const property in input) {
            if (input.hasOwnProperty(property)) {
                output[property] = deepCopy(input[property]);
            }
        }
        return output;
    }
    else {
        return input;
    }
}
const catchRxErrors = (onError, toReturn) => {
    return catchError((e) => {
        onError && onError(e);
        return of(toReturn);
    });
};

/*
 * Public API Surface of utils
 */

let AuthGuard = class AuthGuard {
    constructor(router, auth) {
        this.router = router;
        this.auth = auth;
    }
    canActivate(route, state) {
        return this.auth.check().pipe(tap((status) => {
            if (!status) {
                this.router.navigate([this.auth.signInUrl]);
            }
        }), catchRxErrors((e) => { }, false));
    }
    canActivateChild(route, state) {
        return this.canActivate(route, state);
    }
};
AuthGuard.ctorParameters = () => [
    { type: Router },
    { type: AuthContract }
];
AuthGuard.ɵprov = ɵɵdefineInjectable({ factory: function AuthGuard_Factory() { return new AuthGuard(ɵɵinject(Router), ɵɵinject(AuthContract)); }, token: AuthGuard, providedIn: "root" });
AuthGuard = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AuthGuard);

let UnauthGuard = class UnauthGuard {
    constructor(router, auth) {
        this.router = router;
        this.auth = auth;
    }
    canActivate(route, state) {
        return this.auth.check().pipe(tap((status) => {
            if (status) {
                this.router.navigate([this.auth.dashboardUrl]);
            }
        }), map((status) => {
            return !status;
        }), catchRxErrors((e) => { }, true));
    }
    canActivateChild(route, state) {
        return this.canActivate(route, state);
    }
};
UnauthGuard.ctorParameters = () => [
    { type: Router },
    { type: AuthContract }
];
UnauthGuard.ɵprov = ɵɵdefineInjectable({ factory: function UnauthGuard_Factory() { return new UnauthGuard(ɵɵinject(Router), ɵɵinject(AuthContract)); }, token: UnauthGuard, providedIn: "root" });
UnauthGuard = __decorate([
    Injectable({
        providedIn: 'root'
    })
], UnauthGuard);

/*
 * Public API Surface of services
 */

let StoreSyncInterceptor = class StoreSyncInterceptor {
    // constructor(private cache: RequestCache) {}
    intercept(req, next) {
        // continue if not cachable.
        // if (!isCachable(req)) { return next.handle(req) }
        if (true) {
            return next.handle(req);
        }
        // cache-or-fetch
        // const cachedResponse = this.cache.get(req)
        // return cachedResponse ?
        //   of(cachedResponse) : sendRequest(req, next, this.cache)
    }
};
StoreSyncInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function StoreSyncInterceptor_Factory() { return new StoreSyncInterceptor(); }, token: StoreSyncInterceptor, providedIn: "root" });
StoreSyncInterceptor = __decorate([
    Injectable({
        providedIn: 'root'
    })
], StoreSyncInterceptor);

let AuthInterceptor = class AuthInterceptor {
    constructor(local) {
        this.local = local;
    }
    intercept(req, next) {
        // Get the auth token from the service.
        // Clone the request and replace the original headers with
        // cloned headers, updated with the authorization.
        const authReq = req.clone({
            headers: req.headers.set('Authorization', `Bearer ${this.local.get('token')}`),
        });
        // send cloned request with header to the next handler.
        return next.handle(authReq);
    }
};
AuthInterceptor.ctorParameters = () => [
    { type: KeyValueStoreContract }
];
AuthInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function AuthInterceptor_Factory() { return new AuthInterceptor(ɵɵinject(KeyValueStoreContract)); }, token: AuthInterceptor, providedIn: "root" });
AuthInterceptor = __decorate([
    Injectable({
        providedIn: 'root'
    })
], AuthInterceptor);

let NotifInterceptor = class NotifInterceptor {
    constructor(notif, progress) {
        this.notif = notif;
        this.progress = progress;
    }
    intercept(req, next) {
        this.progressRef = this.progress.ref('myProgress');
        this.progressRef.start();
        // extend server response observable with logging
        return next.handle(req).pipe(
        // things don't always work as planned
        // if things go wrong, try again three times
        // however, delay trial in an incremental manner (multipl of 1 second)
        retryWhen((attempts) => {
            return attempts.pipe(zip(range(1, 4)), mergeMap(([error, i]) => {
                if (i > 2) {
                    return throwError(error);
                }
                return timer(i * 1000);
            }));
        }), 
        // catchError http errors and turn to observable of undefined
        catchError((e) => {
            var _a, _b, _c, _d;
            let title, message;
            if (e.error instanceof ErrorEvent) {
                // A client-side or network error occurred. Handle it accordingly.
                title = 'Client Info';
                message = (_a = e === null || e === void 0 ? void 0 : e.error) === null || _a === void 0 ? void 0 : _a.message;
            }
            else {
                // The backend returned an unsuccessful response code.
                // The response body may contain clues as to what went wrong,
                title = 'Server Info';
                message = (_b = e === null || e === void 0 ? void 0 : e.error) === null || _b === void 0 ? void 0 : _b.message;
                if ((_c = e === null || e === void 0 ? void 0 : e.error) === null || _c === void 0 ? void 0 : _c.errors) {
                    const list = (_d = e === null || e === void 0 ? void 0 : e.error) === null || _d === void 0 ? void 0 : _d.errors;
                    for (const item in list) {
                        if (list.hasOwnProperty(item)) {
                            const element = list[item];
                            message = `<br /> ${element}`;
                        }
                    }
                }
            }
            this.notif.show('error', message, title);
            console.error({ e });
            return throwError({ title, message });
        }), finalize(() => {
            this.progressRef.complete();
        }));
    }
};
NotifInterceptor.ctorParameters = () => [
    { type: NotifyContract },
    { type: NgProgress }
];
NotifInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function NotifInterceptor_Factory() { return new NotifInterceptor(ɵɵinject(NotifyContract), ɵɵinject(NgProgress)); }, token: NotifInterceptor, providedIn: "root" });
NotifInterceptor = __decorate([
    Injectable({
        providedIn: 'root'
    })
], NotifInterceptor);

/*
 * Public API Surface of services
 */

let ParsePipe = class ParsePipe {
    transform(value) {
        let output = null;
        try {
            output = JSON.parse(value);
        }
        catch (error) {
            console.error(error);
        }
        return output;
    }
};
ParsePipe = __decorate([
    Pipe({
        name: 'parse'
    })
], ParsePipe);

/**
 * USAGE:
 * value | truncate: numberOfWords: hasDots
 *
 * EXAMPLE:
 * ipsul lorel kepto | truncate: 2 : true
 */
let TruncatePipe = class TruncatePipe {
    transform(value, numberOfWords = 1, hasDots = false) {
        if (!value) {
            return value;
        }
        const values = value.split(' ');
        const newValue = values.filter((v, i) => i < numberOfWords).map(value => value.trim()).join(' ');
        return (hasDots) ? newValue + ((values.length > numberOfWords) ? '...' : '') : newValue;
    }
};
TruncatePipe = __decorate([
    Pipe({
        name: 'truncate'
    })
], TruncatePipe);

const PRIVILEGE_ENTITIES_DATA = new InjectionToken('privilge.entities.data');
// export const PRIVILEGE_USERS_DATA = new InjectionToken<Object>('privilge.users.data')
let PrivilegeService = class PrivilegeService {
    constructor(privileges) {
        this.privileges = privileges;
    }
    of(user) {
        this.user = user;
        this.policy = user['policy'];
        return this;
    }
    on(entity) {
        this.entity = entity.toLowerCase();
        return this;
    }
    for(ability) {
        this.entity = ability.toLowerCase();
        return this.able(ability) && this.can(ability);
    }
    canCreate() {
        return this.can('create');
    }
    canRead() {
        return this.can('read');
    }
    canUpdate() {
        return this.can('update');
    }
    canDelete() {
        return this.can('delete');
    }
    can(ability) {
        return !!(this.entity && this.policy[this.entity] && this.policy[this.entity].includes(ability));
    }
    creatable() {
        return this.able('create');
    }
    readable() {
        return this.able('read');
    }
    updateable() {
        return this.able('update');
    }
    deleteable() {
        return this.able('delete');
    }
    able(ability) {
        return !!(this.entity && this.privileges[this.entity] && this.privileges[this.entity].includes(ability));
    }
};
PrivilegeService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [PRIVILEGE_ENTITIES_DATA,] }] }
];
PrivilegeService.ɵprov = ɵɵdefineInjectable({ factory: function PrivilegeService_Factory() { return new PrivilegeService(ɵɵinject(PRIVILEGE_ENTITIES_DATA)); }, token: PrivilegeService, providedIn: "root" });
PrivilegeService = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __param(0, Inject(PRIVILEGE_ENTITIES_DATA))
], PrivilegeService);

/**
 * USAGE:
 * entity | of: ability
 *
 * EXAMPLE:
 * user | of: 'create' | async
 */
let PrivilegePipe = class PrivilegePipe {
    constructor(privilege, auth) {
        this.privilege = privilege;
        this.auth = auth;
    }
    transform(entity, ability) {
        return of(true);
        // return this.auth.user().pipe(
        //   map((user) => {
        //     // return this.privilege.of(user).on(entity).for(ability)
        //     return true
        //   })
        // )
    }
};
PrivilegePipe.ctorParameters = () => [
    { type: PrivilegeService },
    { type: AuthContract }
];
PrivilegePipe = __decorate([
    Pipe({
        name: 'of'
    })
], PrivilegePipe);

let ReplacePipe = class ReplacePipe {
    transform(value, search, replace) {
        return typeof value === 'string' ? value.replace(search, replace) : value;
    }
};
ReplacePipe = __decorate([
    Pipe({
        name: 'replace'
    })
], ReplacePipe);

let PrettyPipe = class PrettyPipe {
    transform(value) {
        return value;
    }
};
PrettyPipe = __decorate([
    Pipe({
        name: 'pretty'
    })
], PrettyPipe);

const PIPES = [
    TruncatePipe,
    PrivilegePipe,
    ParsePipe,
    ReplacePipe,
    PrettyPipe,
];
let PipesModule = class PipesModule {
};
PipesModule = __decorate([
    NgModule({
        declarations: [
            PIPES
        ],
        exports: [
            PIPES
        ]
    })
], PipesModule);

/*
 * Public API Surface of services
 */

const state = createFeatureSelector('router');
const { selectCurrentRoute, // select the current route
selectQueryParams, // select the current route query params
selectQueryParam, // factory function to select a query param
selectRouteParams, // select the current route params
selectRouteParam, // factory function to select a route param
selectRouteData, // select the current route data
selectUrl, } = getSelectors(state);

let RouterStoreService = class RouterStoreService {
    constructor(store) {
        this.store = store;
    }
    currentRoute() {
        return this.store.pipe(select(selectCurrentRoute));
    }
    selectQueryParams() {
        return this.store.pipe(select(selectQueryParams));
    }
    selectQueryParam(param) {
        return this.store.pipe(select(selectQueryParam(param)));
    }
    selectRouteParams() {
        return this.store.pipe(select(selectRouteParams));
    }
    selectRouteParam(param) {
        return this.store.pipe(select(selectRouteParam(param)));
    }
    selectRouteData() {
        return this.store.pipe(select(selectRouteData));
    }
    selectUrl() {
        return this.store.pipe(select(selectUrl));
    }
};
RouterStoreService.ctorParameters = () => [
    { type: Store }
];
RouterStoreService.ɵprov = ɵɵdefineInjectable({ factory: function RouterStoreService_Factory() { return new RouterStoreService(ɵɵinject(Store)); }, token: RouterStoreService, providedIn: "root" });
RouterStoreService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], RouterStoreService);

let RouterStoreModule = class RouterStoreModule {
};
RouterStoreModule = __decorate([
    NgModule({
        declarations: [],
        imports: [
            CommonModule,
            StoreModule.forFeature('router', routerReducer),
            // Connects RouterModule with StoreModule, uses MinimalRouterStateSerializer by default
            StoreRouterConnectingModule.forRoot(),
        ],
        exports: [
            StoreRouterConnectingModule,
        ]
    })
], RouterStoreModule);

/*
 * Public API Surface of services
 */

const CONFIG_DATA = new InjectionToken('config.data');
let Config = class Config {
    constructor(config) {
        this.config = config;
    }
    select$(key, source) {
        let keys = key.split('.');
        let rst = source ? source : this.config;
        keys.forEach(function (k) {
            rst = rst && rst[k] ? rst[k] : null;
        });
        return of(rst);
    }
    select(key, source) {
        let keys = key.split('.');
        let rst = source ? source : this.config;
        keys.forEach(function (k) {
            rst = rst && rst[k] ? rst[k] : null;
        });
        return rst;
    }
};
Config.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [CONFIG_DATA,] }] }
];
Config.ɵprov = ɵɵdefineInjectable({ factory: function Config_Factory() { return new Config(ɵɵinject(CONFIG_DATA)); }, token: Config, providedIn: "root" });
Config = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __param(0, Inject(CONFIG_DATA))
], Config);

let Emitter = class Emitter {
    constructor() {
        this.actions = new Subject();
    }
    emit(payload) {
        this.actions.next(payload);
    }
    typeOf(type) {
        return this.actions.pipe(filter((payload) => type === payload.type));
    }
    listen() {
        return this.actions;
    }
};
Emitter.ɵprov = ɵɵdefineInjectable({ factory: function Emitter_Factory() { return new Emitter(); }, token: Emitter, providedIn: "root" });
Emitter = __decorate([
    Injectable({
        providedIn: 'root'
    })
], Emitter);

const NORMAL_JSON_HEADER = {
    'Content-Type': 'application/json',
    Accept: 'application/json',
};
const FILE_JSON_HEADER = {};
let RemoteStore = class RemoteStore {
    constructor(agent, notif) {
        this.agent = agent;
        this.notif = notif;
    }
    aRequest(method, url, payload, moreOptions, isFile = false) {
        // start request and hope things goes as planned
        return this.agent
            .request(method, url, Object.assign({ headers: isFile ? FILE_JSON_HEADER : NORMAL_JSON_HEADER, observe: 'response', body: isFile ? payload : JSON.stringify(payload) }, moreOptions))
            .pipe(switchMap((response) => {
            if (!response
                || !response.status
                || !response.body
                || !response.body['status']
            // || !response.body['data']
            ) {
                this.notif.show('error', 'Netwrok Error. Check your network and try again.');
                return throwError('Netwrok Error. Check your network and try again.');
            }
            if (response.body && response.body['status'] && ['fail', 'error'].includes(response.body['status'])) {
                this.notif.show('info', response.body['message']);
                return throwError(response.body['message']);
            }
            if (response.body && response.body['status'] && ['fail', 'error'].includes(response.body['status'])) {
                this.notif.show('info', response.body['message']);
                return throwError(response.body['message']);
            }
            return of(response.body['data']);
        }), catchRxErrors());
    }
    get(url) {
        return this.aRequest('GET', url);
    }
    post(url, payload) {
        return this.aRequest('POST', url, payload);
    }
    put(url, payload) {
        return this.aRequest('PUT', url, payload);
    }
    delete(url) {
        return this.aRequest('DELETE', url);
    }
    patch(url, payload, moreOptions) {
        return this.aRequest('PATCH', url, payload);
    }
};
RemoteStore.ctorParameters = () => [
    { type: HttpClient },
    { type: NotifyContract }
];
RemoteStore.ɵprov = ɵɵdefineInjectable({ factory: function RemoteStore_Factory() { return new RemoteStore(ɵɵinject(HttpClient), ɵɵinject(NotifyContract)); }, token: RemoteStore, providedIn: "root" });
RemoteStore = __decorate([
    Injectable({
        providedIn: 'root'
    })
], RemoteStore);

let EntityStore = class EntityStore extends RemoteStore {
    constructor(agent, notif, config) {
        super(agent, notif);
        this.config = config;
    }
    entity(name) {
        this.entityName = name;
        return this;
    }
    create(payload) {
        return this.post(`${this.config.select('url.base')}/${this.entityName}`, payload).pipe(map(response => response && response[this.entityName]));
    }
    retrieveOne(id) {
        return this.get(`${this.config.select('url.base')}/${this.entityName}/${id}`).pipe(map(response => response && response[this.entityName]));
    }
    retrieveMany(filter) {
        return this.get(`${this.config.select('url.base')}/${this.entityName}?filter=${JSON.stringify(filter)}`).pipe(map(response => response && response[this.entityName]));
    }
    update(id, payload) {
        return this.put(`${this.config.select('url.base')}/${this.entityName}/${id}`, payload).pipe(map(response => response && response[this.entityName]));
    }
    remove(id) {
        return this.delete(`${this.config.select('url.base')}/${this.entityName}/${id}`).pipe(map(response => response && response[this.entityName]));
    }
};
EntityStore.ctorParameters = () => [
    { type: HttpClient },
    { type: NotifyContract },
    { type: ConfigContract }
];
EntityStore.ɵprov = ɵɵdefineInjectable({ factory: function EntityStore_Factory() { return new EntityStore(ɵɵinject(HttpClient), ɵɵinject(NotifyContract), ɵɵinject(ConfigContract)); }, token: EntityStore, providedIn: "root" });
EntityStore = __decorate([
    Injectable({
        providedIn: 'root'
    })
], EntityStore);

class WebStore {
    constructor(agent) {
        this.agent = agent;
    }
    get$(key, defaultValue) {
        let value = this.agent.getItem(key);
        value = value ? value : defaultValue;
        return of(value);
    }
    set$(key, value) {
        this.agent.setItem(key, value);
        return of(value);
    }
    remove$(key) {
        let value = this.agent.getItem(key);
        this.agent.removeItem(key);
        return of(value);
    }
    get(key, defaultValue) {
        let value = this.agent.getItem(key);
        return value ? value : defaultValue;
    }
    set(key, value) {
        this.agent.setItem(key, value);
        return value;
    }
    remove(key) {
        let value = this.agent.getItem(key);
        this.agent.removeItem(key);
        return value;
    }
}

let LocalStore = class LocalStore extends WebStore {
    constructor() {
        super(localStorage);
    }
};
LocalStore.ɵprov = ɵɵdefineInjectable({ factory: function LocalStore_Factory() { return new LocalStore(); }, token: LocalStore, providedIn: "root" });
LocalStore = __decorate([
    Injectable({
        providedIn: 'root'
    })
], LocalStore);

let RoutingStateService = class RoutingStateService {
    constructor(router) {
        this.router = router;
        this.history = [];
    }
    loadRouting() {
        this.router.events.pipe(filter(e => e instanceof RoutesRecognized), pairwise()).subscribe((events) => {
            this.history = [...this.history, events[0].urlAfterRedirects];
        });
    }
    getHistory() {
        return this.history;
    }
    getPreviousUrl() {
        return this.history[this.history.length - 1] || '/';
    }
    onStart() {
        return this.router.events.pipe(filter((event) => event instanceof NavigationStart), map((event) => event));
    }
    onError() {
        return this.router.events.pipe(filter((event) => event instanceof NavigationError), map((event) => event));
    }
    onCancel() {
        return this.router.events.pipe(filter((event) => event instanceof NavigationCancel), map((event) => event));
    }
    onEnd() {
        return this.router.events.pipe(filter((event) => event instanceof RoutesRecognized), map((event) => event));
    }
};
RoutingStateService.ctorParameters = () => [
    { type: Router }
];
RoutingStateService.ɵprov = ɵɵdefineInjectable({ factory: function RoutingStateService_Factory() { return new RoutingStateService(ɵɵinject(Router)); }, token: RoutingStateService, providedIn: "root" });
RoutingStateService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], RoutingStateService);

let ScriptLoaderService = class ScriptLoaderService {
    constructor() {
        this.scripts = [];
    }
    load(script) {
        return new Observable((observer) => {
            const existingScript = this.scripts.find((s) => s.name == script.name);
            // load only if script has not been loaded before
            if (!existingScript || !existingScript.loaded) {
                // Load the script
                let scriptElement = document.createElement('script');
                scriptElement.type = 'text/javascript';
                scriptElement.src = script.src;
                scriptElement.onload = () => {
                    script.loaded = true;
                    observer.next(script);
                    observer.complete();
                    // Mark the script as loaded in memory
                    this.scripts = [...this.scripts, script];
                };
                scriptElement.onerror = (error) => {
                    observer.error("Couldn't load script " + script.src);
                };
                document.getElementsByTagName('body')[0].appendChild(scriptElement);
            }
        }).pipe(retryWhen((attempts) => {
            return attempts.pipe(zip(range(1, 4)), mergeMap(([error, i]) => {
                if (i > 3) {
                    return throwError(error);
                }
                return timer(i * 1000);
            }));
        }), filter((script) => script.loaded));
    }
};
ScriptLoaderService.ɵprov = ɵɵdefineInjectable({ factory: function ScriptLoaderService_Factory() { return new ScriptLoaderService(); }, token: ScriptLoaderService, providedIn: "root" });
ScriptLoaderService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], ScriptLoaderService);

class RoutingStateContract {
}

let SessionAuthService = class SessionAuthService {
    constructor(remote, local, routingState, config) {
        this.remote = remote;
        this.local = local;
        this.routingState = routingState;
        this.config = config;
        this._intendedUrl = '/';
        this.signInUrl = '/login';
        this.dashboardUrl = '/nghbord';
        this.verifyUrl = '/verify';
        this.signInUrl = this.config.select('auth.signInUrl');
        this.dashboardUrl = this.config.select('auth.dashboardUrl');
        this.verifyUrl = this.config.select('auth.verifyUrl');
    }
    get intendedUrl() {
        const url = this.routingState.getPreviousUrl();
        return url ? url : '/';
    }
    prevUrl() {
        return this.routingState.getPreviousUrl();
    }
    csrf() {
        return this.remote.get(`${this.config.select('url.base')}/sanctum/csrf-cookie`);
    }
    signIn(email, password) {
        return this.csrf().pipe(switchMap(() => {
            return this.remote.post(`${this.config.select('url.base')}/api/auth/login`, { email, password });
        }), map((user) => {
            this._user = user;
            return !!user;
        }));
    }
    signOut() {
        return this.remote.post(`${this.config.select('url.base')}/api/auth/logout`, {}).pipe(map((status) => {
            this._user = null;
            return !!status;
        }));
    }
    check() {
        return this.user().pipe(map((user) => !!user));
    }
    user() {
        return of(this._user).pipe(switchMap((user) => {
            return (user) ? of(user) : this.remote.get(`${this.config.select('url.base')}/api/auth/user`).pipe(map((response) => response && response['user'] && response['user']));
        }), map((user) => {
            return this._user = user;
        }));
    }
};
SessionAuthService.ctorParameters = () => [
    { type: HttpStoreContract },
    { type: KeyValueStoreContract },
    { type: RoutingStateContract },
    { type: ConfigContract }
];
SessionAuthService.ɵprov = ɵɵdefineInjectable({ factory: function SessionAuthService_Factory() { return new SessionAuthService(ɵɵinject(HttpStoreContract), ɵɵinject(KeyValueStoreContract), ɵɵinject(RoutingStateContract), ɵɵinject(ConfigContract)); }, token: SessionAuthService, providedIn: "root" });
SessionAuthService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SessionAuthService);

let SessionStore = class SessionStore extends WebStore {
    constructor() {
        super(sessionStorage);
    }
};
SessionStore.ɵprov = ɵɵdefineInjectable({ factory: function SessionStore_Factory() { return new SessionStore(); }, token: SessionStore, providedIn: "root" });
SessionStore = __decorate([
    Injectable({
        providedIn: 'root'
    })
], SessionStore);

let TitleService = class TitleService {
    constructor(t) {
        this.t = t;
    }
    set(title) {
        this.t.setTitle(title);
    }
    get() {
        return this.t.getTitle();
    }
    get$() {
        return of(this.t.getTitle());
    }
};
TitleService.ctorParameters = () => [
    { type: Title }
];
TitleService.ɵprov = ɵɵdefineInjectable({ factory: function TitleService_Factory() { return new TitleService(ɵɵinject(Title)); }, token: TitleService, providedIn: "root" });
TitleService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], TitleService);

let TokenAuthService = class TokenAuthService {
    constructor(remote, local, config, routingState) {
        this.remote = remote;
        this.local = local;
        this.config = config;
        this.routingState = routingState;
        this._intendedUrl = '/';
        this.signInUrl = '/login';
        this.dashboardUrl = '/dashboard';
        this.verifyUrl = '/verify';
        this.signInUrl = config.select('auth.signInUrl');
        this.dashboardUrl = config.select('auth.dashboardUrl');
        this.verifyUrl = config.select('auth.verifyUrl');
    }
    set intendedUrl(url) {
        if (url.includes('sign-in') || url.includes('sign-out')) {
            this._intendedUrl = this.config.select('auth.dashboard');
        }
        else {
            this._intendedUrl = url;
        }
    }
    get intendedUrl() {
        return this.routingState.getPreviousUrl();
    }
    prevUrl() {
        return this.routingState.getPreviousUrl();
    }
    signIn(email, password) {
        return this.getToken(email, password).pipe(map(({ token }) => {
            this.local.set('token', token);
            return !!token;
        }));
    }
    signOut() {
        return forkJoin([
            this.config.select('store.remote.urls.base'),
        ]).pipe(switchMap(([baseUrl]) => {
            return this.remote.post(`${baseUrl}/api/auth/revoke`, {
                token: this.local.get('token')
            });
        }), map((status) => {
            this.local.remove('token');
            return !(this._user = null);
        }));
    }
    check() {
        const token = this.local.get('token');
        return of(!!token);
    }
    user() {
        return forkJoin([
            this.config.select('store.remote.urls.base'),
            of(this._user)
        ]).pipe(switchMap(([baseUrl, user]) => {
            return (user) ? of(user) : this.remote.get(`${baseUrl}/api/auth/user`).pipe(map((response) => response && response['user'] && response['user']));
        }), map((user) => {
            return this._user = user;
        }));
    }
    token() {
        const token = this.local.get('token');
        return token ? `Bearer ${token}` : '';
    }
    getToken(email, password) {
        return forkJoin([
            this.config.select('store.remote.urls.base'),
            this.config.select('name'),
        ]).pipe(switchMap(([baseUrl, device_name]) => {
            return this.remote.post(`${baseUrl}/api/auth/token`, { email, password, device_name });
        }));
    }
};
TokenAuthService.ctorParameters = () => [
    { type: HttpStoreContract },
    { type: KeyValueStoreContract },
    { type: ConfigContract },
    { type: RoutingStateContract }
];
TokenAuthService.ɵprov = ɵɵdefineInjectable({ factory: function TokenAuthService_Factory() { return new TokenAuthService(ɵɵinject(HttpStoreContract), ɵɵinject(KeyValueStoreContract), ɵɵinject(ConfigContract), ɵɵinject(RoutingStateContract)); }, token: TokenAuthService, providedIn: "root" });
TokenAuthService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], TokenAuthService);

/*
 * Public API Surface of ng-bedrock
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AuthContract, AuthGuard, AuthInterceptor, CONFIG_DATA, Config, ConfigContract, Delay, DirectivesModule, Emitter, EmitterContract, EntityStore, FILE_JSON_HEADER, HttpStoreContract, KeyValueStoreContract, LocalStore, Log, NORMAL_JSON_HEADER, NotifInterceptor, NotifyContract, PIPES, PRIVILEGE_ENTITIES_DATA, ParsePipe, PipesModule, PrivilegePipe, PrivilegeService, RemoteStore, ReplacePipe, RouterStoreModule, RouterStoreService, RoutingStateService, SQLStoreContract, ScriptLoaderService, SessionAuthService, SessionStore, StoreSyncInterceptor, Sync, Tick, TitleService, TokenAuthService, Track, TruncatePipe, UnauthGuard, Unsubscribe, WebStore, arrayGroupBy, camelCase, catchRxErrors, compare, copy, cut, deepCopy, hash, injector, isArray, isBlankString, isFunction, isNullOrUndefined, isNumeric, isObject, isObservable, isUndefined, keys, merge, mergeToArray, numberWithCommas, objectDeepMerge, objectGroupBy, outject, plural, randomString, routeGroupMatcher, setInjector, singular, snakeCase, time, titleCase, toJSON };
//# sourceMappingURL=xbucks-ng-bedrock.js.map
