import { __spread, __decorate, __assign, __read, __param, __extends } from 'tslib';
import { NgModule, ɵɵdefineInjectable, ɵɵinject, Injectable, Pipe, InjectionToken, Inject } from '@angular/core';
import { Router, RoutesRecognized, NavigationStart, NavigationError, NavigationCancel } from '@angular/router';
import { catchError, tap, map, retryWhen, zip, mergeMap, finalize, filter, switchMap, pairwise } from 'rxjs/operators';
import { Observable, of, range, throwError, timer, Subject, forkJoin } from 'rxjs';
import { NgProgress } from 'ngx-progressbar';
import { createFeatureSelector, select, Store, StoreModule } from '@ngrx/store';
import { getSelectors, routerReducer, StoreRouterConnectingModule } from '@ngrx/router-store';
import { CommonModule } from '@angular/common';
import { HttpClient } from '@angular/common/http';
import { Title } from '@angular/platform-browser';

var AuthContract = /** @class */ (function () {
    function AuthContract() {
    }
    return AuthContract;
}());

var NotifyContract = /** @class */ (function () {
    function NotifyContract() {
    }
    return NotifyContract;
}());

var SQLStoreContract = /** @class */ (function () {
    function SQLStoreContract() {
    }
    return SQLStoreContract;
}());

var HttpStoreContract = /** @class */ (function () {
    function HttpStoreContract() {
    }
    return HttpStoreContract;
}());

var KeyValueStoreContract = /** @class */ (function () {
    function KeyValueStoreContract() {
    }
    return KeyValueStoreContract;
}());

var ConfigContract = /** @class */ (function () {
    function ConfigContract() {
    }
    return ConfigContract;
}());

var EmitterContract = /** @class */ (function () {
    function EmitterContract() {
    }
    return EmitterContract;
}());

/*
 * Public API Surface of services
 */

// usage: @delay()
function Delay(milliseconds) {
    if (milliseconds === void 0) { milliseconds = 0; }
    return function (target, key, descriptor) {
        var original = descriptor.value;
        descriptor.value = function () {
            var _this = this;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            setTimeout(function () {
                original.apply(_this, args);
            }, milliseconds);
        };
        return descriptor;
    };
}

// import { environment } from "../../environments/environment"
// usage @Log()
function Log(exceptions, isProduction) {
    if (exceptions === void 0) { exceptions = []; }
    if (isProduction === void 0) { isProduction = false; }
    return function (constructor) {
        if (!isProduction) {
            var _loop_1 = function (prop) {
                var member = this_1[prop];
                if (!exceptions.includes(prop)) {
                    this_1[prop] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        console.log.apply(console, __spread(["%c " + constructor.name + " - " + prop, "color: #4CAF50; font-weight: bold"], args));
                        member && member.apply(this, args);
                    };
                }
            };
            var this_1 = this;
            for (var prop in this) {
                _loop_1(prop);
            }
        }
    };
}

// usage @Sync()
function Sync(constructor) {
    return null;
    // const original = constructor.prototype.ngOnDestroy
    // constructor.prototype.ngOnDestroy = function () {
    //   for ( let prop in this ) {
    //     const property = this[ prop ]
    //     if ( property && (typeof property.unsubscribe === "function") ) {
    //       property.unsubscribe()
    //     }
    //   }
    //   original && typeof original === "function" && original.apply(this, arguments)
    // }
}

// usage: @Tick()
function Tick(milliseconds) {
    if (milliseconds === void 0) { milliseconds = 100; }
    return function (target, key, descriptor) {
        var original = descriptor.value;
        descriptor.value = function () {
            var _this = this;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            setInterval(function () {
                original.apply(_this, args);
            }, milliseconds);
        };
        return descriptor;
    };
}

// @Track('page name')
function Track(pageName) {
    return function (constructor) {
        // const analyticsService = AppModule.injector.get(AnalyticsService)
        var ngOnInit = constructor.prototype.ngOnInit;
        constructor.prototype.ngOnInit = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // analyticsService.visit(pageName)
            ngOnInit && ngOnInit.apply(this, args);
        };
        var ngOnDestroy = constructor.prototype.ngOnDestroy;
        constructor.prototype.ngOnDestroy = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // analyticsService.leave(pageName)
            ngOnDestroy && ngOnDestroy.apply(this, args);
        };
    };
}

// usage @Unsubscribe()
function Unsubscribe(exceptions) {
    if (exceptions === void 0) { exceptions = []; }
    return function (constructor) {
        var original = constructor.prototype.ngOnDestroy;
        constructor.prototype.ngOnDestroy = function () {
            for (var prop in this) {
                var property = this[prop];
                if (!exceptions.includes(prop)) {
                    if (property && (typeof property.unsubscribe === 'function')) {
                        property.unsubscribe();
                    }
                }
            }
            original && typeof original === 'function' && original.apply(this, arguments);
        };
    };
}

/*
 * Public API Surface of services
 */

var DirectivesModule = /** @class */ (function () {
    function DirectivesModule() {
    }
    DirectivesModule = __decorate([
        NgModule({
            declarations: [],
            exports: []
        })
    ], DirectivesModule);
    return DirectivesModule;
}());

function time() {
    return new Date();
}
/**
 * set up a handle for injector
 * to be used to inject services without the contructor
 */
var injector;
function setInjector(anInjector) {
    if (injector) {
        console.error('Programming error: Injector was already set');
    }
    else {
        injector = anInjector;
    }
}
function outject(service) {
    return injector.get(service);
}
function keys(obj) {
    return Object.keys(obj);
}
function cut(oldStr, fullStr) {
    return fullStr.split(oldStr).join('');
}
function titleCase(words, seperator, joiner) {
    if (seperator === void 0) { seperator = ' '; }
    if (joiner === void 0) { joiner = ' '; }
    return words
        .split(seperator)
        .map(function (word) {
        return word.charAt(0).toUpperCase() + word.slice(1).toLowerCase();
    })
        .join(joiner);
}
function camelCase(words, seperator, joiner) {
    if (seperator === void 0) { seperator = '_'; }
    if (joiner === void 0) { joiner = ''; }
    return words
        .split(seperator)
        .map(function (word, i) {
        return i == 0
            ? word.toLowerCase()
            : word.charAt(0).toUpperCase() + word.slice(1).toLowerCase();
    })
        .join(joiner);
}
function merge() {
    var objects = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        objects[_i] = arguments[_i];
    }
    return objects.reduce(function (prev, curr, index) {
        return __assign(__assign({}, prev), curr);
    }, {});
}
function mergeToArray() {
    var items = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        items[_i] = arguments[_i];
    }
    return items.reduce(function (prev, curr, index) {
        return __spread(prev, curr);
    }, []);
}
function hash(input) {
    return input ? input : Math.random().toString();
}
function plural(word) {
    return word + "s";
}
function singular(word) {
    return word;
}
function snakeCase(words, seperator, joiner) {
    if (seperator === void 0) { seperator = ' '; }
    if (joiner === void 0) { joiner = '_'; }
    return (words
        // insert a space between lower & upper
        .replace(/([a-z])([A-Z])/g, '$1 $2')
        // space before last upper in a sequence followed by lower
        .replace(/\b([A-Z]+)([A-Z])([a-z])/, '$1 $2$3')
        // replace space with "_"
        .replace(/ +/g, '_')
        // lowercase everything
        .toLowerCase());
}
function isNumeric(str) {
    return !isNullOrUndefined(str) && /^\d+$/.test(str);
}
function isNullOrUndefined(value) {
    return value === undefined || value === null;
}
function isUndefined(value) {
    return value === undefined;
}
function isBlankString(value) {
    return value === '';
}
function isFunction(value) {
    return typeof value === 'function';
}
function isObject(x) {
    return x != null && typeof x === 'object';
}
function isArray(x) {
    return x != null && typeof x === 'object' && Array.isArray(x);
}
function toJSON(mayBeJSON, returnJSON) {
    if (returnJSON === void 0) { returnJSON = false; }
    try {
        var obj = JSON.parse(mayBeJSON);
        if (obj && typeof obj === 'object') {
            return returnJSON ? obj : true;
        }
    }
    catch (e) { }
    return false;
}
function compare(a, b, isAsc, type) {
    if (typeof a === 'string' && type === 'string') {
        return a.localeCompare(b) * (isAsc ? 1 : -1);
    }
    if (typeof a === 'number' && type === 'number') {
        return (a < b ? -1 : 1) * (isAsc ? 1 : -1);
    }
    if (typeof a === 'string' && type === 'time') {
        return ((new Date(a).getTime() < new Date(b).getTime() ? -1 : 1) *
            (isAsc ? 1 : -1));
    }
}
function routeGroupMatcher(haystack) {
    return function (segments, segmentGroup, route) {
        return segments.length === 1 &&
            haystack.includes(segments[0].path.toLowerCase())
            ? { consumed: segments }
            : null;
    };
}
function numberWithCommas(number) {
    if (isNullOrUndefined(number)) {
        return '0';
    }
    var parts = number.toString().split('.');
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ',');
    return parts.join('.');
}
// console.log(objectGroupBy(['one', 'two', 'three'], 'length'))
// => {3: ["one", "two"], 5: ["three"]}
// key can be a sort callback function
// todo: nice es6 typings function<TItem>(xs: TItem[], key: string) : {[key: string]: TItem[]} {
function objectGroupBy(input, key) {
    return input.reduce(function (prev, curr) {
        var newKey = key instanceof Function
            ? key(curr)
            : curr[key]((prev[curr[newKey]] = prev[curr[newKey]] || [])).push(curr);
        return prev;
    }, {});
}
function arrayGroupBy(input, key) {
    if (isNullOrUndefined(input) || input.length < 1) {
        return [];
    }
    return input.reduce(function (prev, curr) {
        if (isNullOrUndefined(curr) || curr.length < 1) {
            return prev;
        }
        var v = key instanceof Function ? key(curr) : curr[key];
        var el = prev.find(function (r) { return r && r.key === v; });
        if (el) {
            el.values.push(curr);
        }
        else {
            prev.push({ key: v, values: [curr] });
        }
        return prev;
    }, []);
}
function objectDeepMerge(input) {
    return input.reduce(function (prev, curr) {
        for (var key in curr) {
            if (curr.hasOwnProperty(key)) {
                prev[key] = __spread((prev[key] || []), [curr[key]]);
            }
        }
        return prev;
    }, {});
}
function randomString(length) {
    if (length === void 0) { length = 7; }
    length = 2 + length / 2;
    return (Math.random()
        .toString(36)
        .substring(2, length) +
        Math.random()
            .toString(36)
            .substring(2, length));
}
function isObservable(mayBeObservable) {
    return mayBeObservable instanceof Observable;
}
function copy(obj) {
    return JSON.parse(JSON.stringify(obj));
}
function deepCopy(input) {
    if (isArray(input)) {
        return input['map'](function (i) { return deepCopy(i); });
    }
    else if (isObject(input)) {
        var output = {};
        for (var property in input) {
            if (input.hasOwnProperty(property)) {
                output[property] = deepCopy(input[property]);
            }
        }
        return output;
    }
    else {
        return input;
    }
}
var catchRxErrors = function (onError, toReturn) {
    return catchError(function (e) {
        onError && onError(e);
        return of(toReturn);
    });
};

/*
 * Public API Surface of utils
 */

var AuthGuard = /** @class */ (function () {
    function AuthGuard(router, auth) {
        this.router = router;
        this.auth = auth;
    }
    AuthGuard.prototype.canActivate = function (route, state) {
        var _this = this;
        return this.auth.check().pipe(tap(function (status) {
            if (!status) {
                _this.router.navigate([_this.auth.signInUrl]);
            }
        }), catchRxErrors(function (e) { }, false));
    };
    AuthGuard.prototype.canActivateChild = function (route, state) {
        return this.canActivate(route, state);
    };
    AuthGuard.ctorParameters = function () { return [
        { type: Router },
        { type: AuthContract }
    ]; };
    AuthGuard.ɵprov = ɵɵdefineInjectable({ factory: function AuthGuard_Factory() { return new AuthGuard(ɵɵinject(Router), ɵɵinject(AuthContract)); }, token: AuthGuard, providedIn: "root" });
    AuthGuard = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], AuthGuard);
    return AuthGuard;
}());

var UnauthGuard = /** @class */ (function () {
    function UnauthGuard(router, auth) {
        this.router = router;
        this.auth = auth;
    }
    UnauthGuard.prototype.canActivate = function (route, state) {
        var _this = this;
        return this.auth.check().pipe(tap(function (status) {
            if (status) {
                _this.router.navigate([_this.auth.dashboardUrl]);
            }
        }), map(function (status) {
            return !status;
        }), catchRxErrors(function (e) { }, true));
    };
    UnauthGuard.prototype.canActivateChild = function (route, state) {
        return this.canActivate(route, state);
    };
    UnauthGuard.ctorParameters = function () { return [
        { type: Router },
        { type: AuthContract }
    ]; };
    UnauthGuard.ɵprov = ɵɵdefineInjectable({ factory: function UnauthGuard_Factory() { return new UnauthGuard(ɵɵinject(Router), ɵɵinject(AuthContract)); }, token: UnauthGuard, providedIn: "root" });
    UnauthGuard = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], UnauthGuard);
    return UnauthGuard;
}());

/*
 * Public API Surface of services
 */

var StoreSyncInterceptor = /** @class */ (function () {
    function StoreSyncInterceptor() {
    }
    // constructor(private cache: RequestCache) {}
    StoreSyncInterceptor.prototype.intercept = function (req, next) {
        // continue if not cachable.
        // if (!isCachable(req)) { return next.handle(req) }
        if (true) {
            return next.handle(req);
        }
        // cache-or-fetch
        // const cachedResponse = this.cache.get(req)
        // return cachedResponse ?
        //   of(cachedResponse) : sendRequest(req, next, this.cache)
    };
    StoreSyncInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function StoreSyncInterceptor_Factory() { return new StoreSyncInterceptor(); }, token: StoreSyncInterceptor, providedIn: "root" });
    StoreSyncInterceptor = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], StoreSyncInterceptor);
    return StoreSyncInterceptor;
}());

var AuthInterceptor = /** @class */ (function () {
    function AuthInterceptor(local) {
        this.local = local;
    }
    AuthInterceptor.prototype.intercept = function (req, next) {
        // Get the auth token from the service.
        // Clone the request and replace the original headers with
        // cloned headers, updated with the authorization.
        var authReq = req.clone({
            headers: req.headers.set('Authorization', "Bearer " + this.local.get('token')),
        });
        // send cloned request with header to the next handler.
        return next.handle(authReq);
    };
    AuthInterceptor.ctorParameters = function () { return [
        { type: KeyValueStoreContract }
    ]; };
    AuthInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function AuthInterceptor_Factory() { return new AuthInterceptor(ɵɵinject(KeyValueStoreContract)); }, token: AuthInterceptor, providedIn: "root" });
    AuthInterceptor = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], AuthInterceptor);
    return AuthInterceptor;
}());

var NotifInterceptor = /** @class */ (function () {
    function NotifInterceptor(notif, progress) {
        this.notif = notif;
        this.progress = progress;
    }
    NotifInterceptor.prototype.intercept = function (req, next) {
        var _this = this;
        this.progressRef = this.progress.ref('myProgress');
        this.progressRef.start();
        // extend server response observable with logging
        return next.handle(req).pipe(
        // things don't always work as planned
        // if things go wrong, try again three times
        // however, delay trial in an incremental manner (multipl of 1 second)
        retryWhen(function (attempts) {
            return attempts.pipe(zip(range(1, 4)), mergeMap(function (_a) {
                var _b = __read(_a, 2), error = _b[0], i = _b[1];
                if (i > 2) {
                    return throwError(error);
                }
                return timer(i * 1000);
            }));
        }), 
        // catchError http errors and turn to observable of undefined
        catchError(function (e) {
            var _a, _b, _c, _d;
            var title, message;
            if (e.error instanceof ErrorEvent) {
                // A client-side or network error occurred. Handle it accordingly.
                title = 'Client Info';
                message = (_a = e === null || e === void 0 ? void 0 : e.error) === null || _a === void 0 ? void 0 : _a.message;
            }
            else {
                // The backend returned an unsuccessful response code.
                // The response body may contain clues as to what went wrong,
                title = 'Server Info';
                message = (_b = e === null || e === void 0 ? void 0 : e.error) === null || _b === void 0 ? void 0 : _b.message;
                if ((_c = e === null || e === void 0 ? void 0 : e.error) === null || _c === void 0 ? void 0 : _c.errors) {
                    var list = (_d = e === null || e === void 0 ? void 0 : e.error) === null || _d === void 0 ? void 0 : _d.errors;
                    for (var item in list) {
                        if (list.hasOwnProperty(item)) {
                            var element = list[item];
                            message = "<br /> " + element;
                        }
                    }
                }
            }
            _this.notif.show('error', message, title);
            console.error({ e: e });
            return throwError({ title: title, message: message });
        }), finalize(function () {
            _this.progressRef.complete();
        }));
    };
    NotifInterceptor.ctorParameters = function () { return [
        { type: NotifyContract },
        { type: NgProgress }
    ]; };
    NotifInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function NotifInterceptor_Factory() { return new NotifInterceptor(ɵɵinject(NotifyContract), ɵɵinject(NgProgress)); }, token: NotifInterceptor, providedIn: "root" });
    NotifInterceptor = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], NotifInterceptor);
    return NotifInterceptor;
}());

/*
 * Public API Surface of services
 */

var ParsePipe = /** @class */ (function () {
    function ParsePipe() {
    }
    ParsePipe.prototype.transform = function (value) {
        var output = null;
        try {
            output = JSON.parse(value);
        }
        catch (error) {
            console.error(error);
        }
        return output;
    };
    ParsePipe = __decorate([
        Pipe({
            name: 'parse'
        })
    ], ParsePipe);
    return ParsePipe;
}());

/**
 * USAGE:
 * value | truncate: numberOfWords: hasDots
 *
 * EXAMPLE:
 * ipsul lorel kepto | truncate: 2 : true
 */
var TruncatePipe = /** @class */ (function () {
    function TruncatePipe() {
    }
    TruncatePipe.prototype.transform = function (value, numberOfWords, hasDots) {
        if (numberOfWords === void 0) { numberOfWords = 1; }
        if (hasDots === void 0) { hasDots = false; }
        if (!value) {
            return value;
        }
        var values = value.split(' ');
        var newValue = values.filter(function (v, i) { return i < numberOfWords; }).map(function (value) { return value.trim(); }).join(' ');
        return (hasDots) ? newValue + ((values.length > numberOfWords) ? '...' : '') : newValue;
    };
    TruncatePipe = __decorate([
        Pipe({
            name: 'truncate'
        })
    ], TruncatePipe);
    return TruncatePipe;
}());

var PRIVILEGE_ENTITIES_DATA = new InjectionToken('privilge.entities.data');
// export const PRIVILEGE_USERS_DATA = new InjectionToken<Object>('privilge.users.data')
var PrivilegeService = /** @class */ (function () {
    function PrivilegeService(privileges) {
        this.privileges = privileges;
    }
    PrivilegeService.prototype.of = function (user) {
        this.user = user;
        this.policy = user['policy'];
        return this;
    };
    PrivilegeService.prototype.on = function (entity) {
        this.entity = entity.toLowerCase();
        return this;
    };
    PrivilegeService.prototype.for = function (ability) {
        this.entity = ability.toLowerCase();
        return this.able(ability) && this.can(ability);
    };
    PrivilegeService.prototype.canCreate = function () {
        return this.can('create');
    };
    PrivilegeService.prototype.canRead = function () {
        return this.can('read');
    };
    PrivilegeService.prototype.canUpdate = function () {
        return this.can('update');
    };
    PrivilegeService.prototype.canDelete = function () {
        return this.can('delete');
    };
    PrivilegeService.prototype.can = function (ability) {
        return !!(this.entity && this.policy[this.entity] && this.policy[this.entity].includes(ability));
    };
    PrivilegeService.prototype.creatable = function () {
        return this.able('create');
    };
    PrivilegeService.prototype.readable = function () {
        return this.able('read');
    };
    PrivilegeService.prototype.updateable = function () {
        return this.able('update');
    };
    PrivilegeService.prototype.deleteable = function () {
        return this.able('delete');
    };
    PrivilegeService.prototype.able = function (ability) {
        return !!(this.entity && this.privileges[this.entity] && this.privileges[this.entity].includes(ability));
    };
    PrivilegeService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [PRIVILEGE_ENTITIES_DATA,] }] }
    ]; };
    PrivilegeService.ɵprov = ɵɵdefineInjectable({ factory: function PrivilegeService_Factory() { return new PrivilegeService(ɵɵinject(PRIVILEGE_ENTITIES_DATA)); }, token: PrivilegeService, providedIn: "root" });
    PrivilegeService = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __param(0, Inject(PRIVILEGE_ENTITIES_DATA))
    ], PrivilegeService);
    return PrivilegeService;
}());

/**
 * USAGE:
 * entity | of: ability
 *
 * EXAMPLE:
 * user | of: 'create' | async
 */
var PrivilegePipe = /** @class */ (function () {
    function PrivilegePipe(privilege, auth) {
        this.privilege = privilege;
        this.auth = auth;
    }
    PrivilegePipe.prototype.transform = function (entity, ability) {
        return of(true);
        // return this.auth.user().pipe(
        //   map((user) => {
        //     // return this.privilege.of(user).on(entity).for(ability)
        //     return true
        //   })
        // )
    };
    PrivilegePipe.ctorParameters = function () { return [
        { type: PrivilegeService },
        { type: AuthContract }
    ]; };
    PrivilegePipe = __decorate([
        Pipe({
            name: 'of'
        })
    ], PrivilegePipe);
    return PrivilegePipe;
}());

var ReplacePipe = /** @class */ (function () {
    function ReplacePipe() {
    }
    ReplacePipe.prototype.transform = function (value, search, replace) {
        return typeof value === 'string' ? value.replace(search, replace) : value;
    };
    ReplacePipe = __decorate([
        Pipe({
            name: 'replace'
        })
    ], ReplacePipe);
    return ReplacePipe;
}());

var PrettyPipe = /** @class */ (function () {
    function PrettyPipe() {
    }
    PrettyPipe.prototype.transform = function (value) {
        return value;
    };
    PrettyPipe = __decorate([
        Pipe({
            name: 'pretty'
        })
    ], PrettyPipe);
    return PrettyPipe;
}());

var PIPES = [
    TruncatePipe,
    PrivilegePipe,
    ParsePipe,
    ReplacePipe,
    PrettyPipe,
];
var PipesModule = /** @class */ (function () {
    function PipesModule() {
    }
    PipesModule = __decorate([
        NgModule({
            declarations: [
                PIPES
            ],
            exports: [
                PIPES
            ]
        })
    ], PipesModule);
    return PipesModule;
}());

/*
 * Public API Surface of services
 */

var _a;
var state = createFeatureSelector('router');
var selectCurrentRoute = (_a = getSelectors(state), _a.selectCurrentRoute), // select the current route
selectQueryParams = _a.selectQueryParams, // select the current route query params
selectQueryParam = _a.selectQueryParam, // factory function to select a query param
selectRouteParams = _a.selectRouteParams, // select the current route params
selectRouteParam = _a.selectRouteParam, // factory function to select a route param
selectRouteData = _a.selectRouteData, // select the current route data
selectUrl = _a.selectUrl;

var RouterStoreService = /** @class */ (function () {
    function RouterStoreService(store) {
        this.store = store;
    }
    RouterStoreService.prototype.currentRoute = function () {
        return this.store.pipe(select(selectCurrentRoute));
    };
    RouterStoreService.prototype.selectQueryParams = function () {
        return this.store.pipe(select(selectQueryParams));
    };
    RouterStoreService.prototype.selectQueryParam = function (param) {
        return this.store.pipe(select(selectQueryParam(param)));
    };
    RouterStoreService.prototype.selectRouteParams = function () {
        return this.store.pipe(select(selectRouteParams));
    };
    RouterStoreService.prototype.selectRouteParam = function (param) {
        return this.store.pipe(select(selectRouteParam(param)));
    };
    RouterStoreService.prototype.selectRouteData = function () {
        return this.store.pipe(select(selectRouteData));
    };
    RouterStoreService.prototype.selectUrl = function () {
        return this.store.pipe(select(selectUrl));
    };
    RouterStoreService.ctorParameters = function () { return [
        { type: Store }
    ]; };
    RouterStoreService.ɵprov = ɵɵdefineInjectable({ factory: function RouterStoreService_Factory() { return new RouterStoreService(ɵɵinject(Store)); }, token: RouterStoreService, providedIn: "root" });
    RouterStoreService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], RouterStoreService);
    return RouterStoreService;
}());

var RouterStoreModule = /** @class */ (function () {
    function RouterStoreModule() {
    }
    RouterStoreModule = __decorate([
        NgModule({
            declarations: [],
            imports: [
                CommonModule,
                StoreModule.forFeature('router', routerReducer),
                // Connects RouterModule with StoreModule, uses MinimalRouterStateSerializer by default
                StoreRouterConnectingModule.forRoot(),
            ],
            exports: [
                StoreRouterConnectingModule,
            ]
        })
    ], RouterStoreModule);
    return RouterStoreModule;
}());

/*
 * Public API Surface of services
 */

var CONFIG_DATA = new InjectionToken('config.data');
var Config = /** @class */ (function () {
    function Config(config) {
        this.config = config;
    }
    Config.prototype.select$ = function (key, source) {
        var keys = key.split('.');
        var rst = source ? source : this.config;
        keys.forEach(function (k) {
            rst = rst && rst[k] ? rst[k] : null;
        });
        return of(rst);
    };
    Config.prototype.select = function (key, source) {
        var keys = key.split('.');
        var rst = source ? source : this.config;
        keys.forEach(function (k) {
            rst = rst && rst[k] ? rst[k] : null;
        });
        return rst;
    };
    Config.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [CONFIG_DATA,] }] }
    ]; };
    Config.ɵprov = ɵɵdefineInjectable({ factory: function Config_Factory() { return new Config(ɵɵinject(CONFIG_DATA)); }, token: Config, providedIn: "root" });
    Config = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __param(0, Inject(CONFIG_DATA))
    ], Config);
    return Config;
}());

var Emitter = /** @class */ (function () {
    function Emitter() {
        this.actions = new Subject();
    }
    Emitter.prototype.emit = function (payload) {
        this.actions.next(payload);
    };
    Emitter.prototype.typeOf = function (type) {
        return this.actions.pipe(filter(function (payload) { return type === payload.type; }));
    };
    Emitter.prototype.listen = function () {
        return this.actions;
    };
    Emitter.ɵprov = ɵɵdefineInjectable({ factory: function Emitter_Factory() { return new Emitter(); }, token: Emitter, providedIn: "root" });
    Emitter = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], Emitter);
    return Emitter;
}());

var NORMAL_JSON_HEADER = {
    'Content-Type': 'application/json',
    Accept: 'application/json',
};
var FILE_JSON_HEADER = {};
var RemoteStore = /** @class */ (function () {
    function RemoteStore(agent, notif) {
        this.agent = agent;
        this.notif = notif;
    }
    RemoteStore.prototype.aRequest = function (method, url, payload, moreOptions, isFile) {
        var _this = this;
        if (isFile === void 0) { isFile = false; }
        // start request and hope things goes as planned
        return this.agent
            .request(method, url, __assign({ headers: isFile ? FILE_JSON_HEADER : NORMAL_JSON_HEADER, observe: 'response', body: isFile ? payload : JSON.stringify(payload) }, moreOptions))
            .pipe(switchMap(function (response) {
            if (!response
                || !response.status
                || !response.body
                || !response.body['status']
            // || !response.body['data']
            ) {
                _this.notif.show('error', 'Netwrok Error. Check your network and try again.');
                return throwError('Netwrok Error. Check your network and try again.');
            }
            if (response.body && response.body['status'] && ['fail', 'error'].includes(response.body['status'])) {
                _this.notif.show('info', response.body['message']);
                return throwError(response.body['message']);
            }
            if (response.body && response.body['status'] && ['fail', 'error'].includes(response.body['status'])) {
                _this.notif.show('info', response.body['message']);
                return throwError(response.body['message']);
            }
            return of(response.body['data']);
        }), catchRxErrors());
    };
    RemoteStore.prototype.get = function (url) {
        return this.aRequest('GET', url);
    };
    RemoteStore.prototype.post = function (url, payload) {
        return this.aRequest('POST', url, payload);
    };
    RemoteStore.prototype.put = function (url, payload) {
        return this.aRequest('PUT', url, payload);
    };
    RemoteStore.prototype.delete = function (url) {
        return this.aRequest('DELETE', url);
    };
    RemoteStore.prototype.patch = function (url, payload, moreOptions) {
        return this.aRequest('PATCH', url, payload);
    };
    RemoteStore.ctorParameters = function () { return [
        { type: HttpClient },
        { type: NotifyContract }
    ]; };
    RemoteStore.ɵprov = ɵɵdefineInjectable({ factory: function RemoteStore_Factory() { return new RemoteStore(ɵɵinject(HttpClient), ɵɵinject(NotifyContract)); }, token: RemoteStore, providedIn: "root" });
    RemoteStore = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], RemoteStore);
    return RemoteStore;
}());

var EntityStore = /** @class */ (function (_super) {
    __extends(EntityStore, _super);
    function EntityStore(agent, notif, config) {
        var _this = _super.call(this, agent, notif) || this;
        _this.config = config;
        return _this;
    }
    EntityStore.prototype.entity = function (name) {
        this.entityName = name;
        return this;
    };
    EntityStore.prototype.create = function (payload) {
        var _this = this;
        return this.post(this.config.select('url.base') + "/" + this.entityName, payload).pipe(map(function (response) { return response && response[_this.entityName]; }));
    };
    EntityStore.prototype.retrieveOne = function (id) {
        var _this = this;
        return this.get(this.config.select('url.base') + "/" + this.entityName + "/" + id).pipe(map(function (response) { return response && response[_this.entityName]; }));
    };
    EntityStore.prototype.retrieveMany = function (filter) {
        var _this = this;
        return this.get(this.config.select('url.base') + "/" + this.entityName + "?filter=" + JSON.stringify(filter)).pipe(map(function (response) { return response && response[_this.entityName]; }));
    };
    EntityStore.prototype.update = function (id, payload) {
        var _this = this;
        return this.put(this.config.select('url.base') + "/" + this.entityName + "/" + id, payload).pipe(map(function (response) { return response && response[_this.entityName]; }));
    };
    EntityStore.prototype.remove = function (id) {
        var _this = this;
        return this.delete(this.config.select('url.base') + "/" + this.entityName + "/" + id).pipe(map(function (response) { return response && response[_this.entityName]; }));
    };
    EntityStore.ctorParameters = function () { return [
        { type: HttpClient },
        { type: NotifyContract },
        { type: ConfigContract }
    ]; };
    EntityStore.ɵprov = ɵɵdefineInjectable({ factory: function EntityStore_Factory() { return new EntityStore(ɵɵinject(HttpClient), ɵɵinject(NotifyContract), ɵɵinject(ConfigContract)); }, token: EntityStore, providedIn: "root" });
    EntityStore = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], EntityStore);
    return EntityStore;
}(RemoteStore));

var WebStore = /** @class */ (function () {
    function WebStore(agent) {
        this.agent = agent;
    }
    WebStore.prototype.get$ = function (key, defaultValue) {
        var value = this.agent.getItem(key);
        value = value ? value : defaultValue;
        return of(value);
    };
    WebStore.prototype.set$ = function (key, value) {
        this.agent.setItem(key, value);
        return of(value);
    };
    WebStore.prototype.remove$ = function (key) {
        var value = this.agent.getItem(key);
        this.agent.removeItem(key);
        return of(value);
    };
    WebStore.prototype.get = function (key, defaultValue) {
        var value = this.agent.getItem(key);
        return value ? value : defaultValue;
    };
    WebStore.prototype.set = function (key, value) {
        this.agent.setItem(key, value);
        return value;
    };
    WebStore.prototype.remove = function (key) {
        var value = this.agent.getItem(key);
        this.agent.removeItem(key);
        return value;
    };
    return WebStore;
}());

var LocalStore = /** @class */ (function (_super) {
    __extends(LocalStore, _super);
    function LocalStore() {
        return _super.call(this, localStorage) || this;
    }
    LocalStore.ɵprov = ɵɵdefineInjectable({ factory: function LocalStore_Factory() { return new LocalStore(); }, token: LocalStore, providedIn: "root" });
    LocalStore = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], LocalStore);
    return LocalStore;
}(WebStore));

var RoutingStateService = /** @class */ (function () {
    function RoutingStateService(router) {
        this.router = router;
        this.history = [];
    }
    RoutingStateService.prototype.loadRouting = function () {
        var _this = this;
        this.router.events.pipe(filter(function (e) { return e instanceof RoutesRecognized; }), pairwise()).subscribe(function (events) {
            _this.history = __spread(_this.history, [events[0].urlAfterRedirects]);
        });
    };
    RoutingStateService.prototype.getHistory = function () {
        return this.history;
    };
    RoutingStateService.prototype.getPreviousUrl = function () {
        return this.history[this.history.length - 1] || '/';
    };
    RoutingStateService.prototype.onStart = function () {
        return this.router.events.pipe(filter(function (event) { return event instanceof NavigationStart; }), map(function (event) { return event; }));
    };
    RoutingStateService.prototype.onError = function () {
        return this.router.events.pipe(filter(function (event) { return event instanceof NavigationError; }), map(function (event) { return event; }));
    };
    RoutingStateService.prototype.onCancel = function () {
        return this.router.events.pipe(filter(function (event) { return event instanceof NavigationCancel; }), map(function (event) { return event; }));
    };
    RoutingStateService.prototype.onEnd = function () {
        return this.router.events.pipe(filter(function (event) { return event instanceof RoutesRecognized; }), map(function (event) { return event; }));
    };
    RoutingStateService.ctorParameters = function () { return [
        { type: Router }
    ]; };
    RoutingStateService.ɵprov = ɵɵdefineInjectable({ factory: function RoutingStateService_Factory() { return new RoutingStateService(ɵɵinject(Router)); }, token: RoutingStateService, providedIn: "root" });
    RoutingStateService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], RoutingStateService);
    return RoutingStateService;
}());

var ScriptLoaderService = /** @class */ (function () {
    function ScriptLoaderService() {
        this.scripts = [];
    }
    ScriptLoaderService.prototype.load = function (script) {
        var _this = this;
        return new Observable(function (observer) {
            var existingScript = _this.scripts.find(function (s) { return s.name == script.name; });
            // load only if script has not been loaded before
            if (!existingScript || !existingScript.loaded) {
                // Load the script
                var scriptElement = document.createElement('script');
                scriptElement.type = 'text/javascript';
                scriptElement.src = script.src;
                scriptElement.onload = function () {
                    script.loaded = true;
                    observer.next(script);
                    observer.complete();
                    // Mark the script as loaded in memory
                    _this.scripts = __spread(_this.scripts, [script]);
                };
                scriptElement.onerror = function (error) {
                    observer.error("Couldn't load script " + script.src);
                };
                document.getElementsByTagName('body')[0].appendChild(scriptElement);
            }
        }).pipe(retryWhen(function (attempts) {
            return attempts.pipe(zip(range(1, 4)), mergeMap(function (_a) {
                var _b = __read(_a, 2), error = _b[0], i = _b[1];
                if (i > 3) {
                    return throwError(error);
                }
                return timer(i * 1000);
            }));
        }), filter(function (script) { return script.loaded; }));
    };
    ScriptLoaderService.ɵprov = ɵɵdefineInjectable({ factory: function ScriptLoaderService_Factory() { return new ScriptLoaderService(); }, token: ScriptLoaderService, providedIn: "root" });
    ScriptLoaderService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], ScriptLoaderService);
    return ScriptLoaderService;
}());

var RoutingStateContract = /** @class */ (function () {
    function RoutingStateContract() {
    }
    return RoutingStateContract;
}());

var SessionAuthService = /** @class */ (function () {
    function SessionAuthService(remote, local, routingState, config) {
        this.remote = remote;
        this.local = local;
        this.routingState = routingState;
        this.config = config;
        this._intendedUrl = '/';
        this.signInUrl = '/login';
        this.dashboardUrl = '/nghbord';
        this.verifyUrl = '/verify';
        this.signInUrl = this.config.select('auth.signInUrl');
        this.dashboardUrl = this.config.select('auth.dashboardUrl');
        this.verifyUrl = this.config.select('auth.verifyUrl');
    }
    Object.defineProperty(SessionAuthService.prototype, "intendedUrl", {
        get: function () {
            var url = this.routingState.getPreviousUrl();
            return url ? url : '/';
        },
        enumerable: true,
        configurable: true
    });
    SessionAuthService.prototype.prevUrl = function () {
        return this.routingState.getPreviousUrl();
    };
    SessionAuthService.prototype.csrf = function () {
        return this.remote.get(this.config.select('url.base') + "/sanctum/csrf-cookie");
    };
    SessionAuthService.prototype.signIn = function (email, password) {
        var _this = this;
        return this.csrf().pipe(switchMap(function () {
            return _this.remote.post(_this.config.select('url.base') + "/api/auth/login", { email: email, password: password });
        }), map(function (user) {
            _this._user = user;
            return !!user;
        }));
    };
    SessionAuthService.prototype.signOut = function () {
        var _this = this;
        return this.remote.post(this.config.select('url.base') + "/api/auth/logout", {}).pipe(map(function (status) {
            _this._user = null;
            return !!status;
        }));
    };
    SessionAuthService.prototype.check = function () {
        return this.user().pipe(map(function (user) { return !!user; }));
    };
    SessionAuthService.prototype.user = function () {
        var _this = this;
        return of(this._user).pipe(switchMap(function (user) {
            return (user) ? of(user) : _this.remote.get(_this.config.select('url.base') + "/api/auth/user").pipe(map(function (response) { return response && response['user'] && response['user']; }));
        }), map(function (user) {
            return _this._user = user;
        }));
    };
    SessionAuthService.ctorParameters = function () { return [
        { type: HttpStoreContract },
        { type: KeyValueStoreContract },
        { type: RoutingStateContract },
        { type: ConfigContract }
    ]; };
    SessionAuthService.ɵprov = ɵɵdefineInjectable({ factory: function SessionAuthService_Factory() { return new SessionAuthService(ɵɵinject(HttpStoreContract), ɵɵinject(KeyValueStoreContract), ɵɵinject(RoutingStateContract), ɵɵinject(ConfigContract)); }, token: SessionAuthService, providedIn: "root" });
    SessionAuthService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], SessionAuthService);
    return SessionAuthService;
}());

var SessionStore = /** @class */ (function (_super) {
    __extends(SessionStore, _super);
    function SessionStore() {
        return _super.call(this, sessionStorage) || this;
    }
    SessionStore.ɵprov = ɵɵdefineInjectable({ factory: function SessionStore_Factory() { return new SessionStore(); }, token: SessionStore, providedIn: "root" });
    SessionStore = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], SessionStore);
    return SessionStore;
}(WebStore));

var TitleService = /** @class */ (function () {
    function TitleService(t) {
        this.t = t;
    }
    TitleService.prototype.set = function (title) {
        this.t.setTitle(title);
    };
    TitleService.prototype.get = function () {
        return this.t.getTitle();
    };
    TitleService.prototype.get$ = function () {
        return of(this.t.getTitle());
    };
    TitleService.ctorParameters = function () { return [
        { type: Title }
    ]; };
    TitleService.ɵprov = ɵɵdefineInjectable({ factory: function TitleService_Factory() { return new TitleService(ɵɵinject(Title)); }, token: TitleService, providedIn: "root" });
    TitleService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], TitleService);
    return TitleService;
}());

var TokenAuthService = /** @class */ (function () {
    function TokenAuthService(remote, local, config, routingState) {
        this.remote = remote;
        this.local = local;
        this.config = config;
        this.routingState = routingState;
        this._intendedUrl = '/';
        this.signInUrl = '/login';
        this.dashboardUrl = '/dashboard';
        this.verifyUrl = '/verify';
        this.signInUrl = config.select('auth.signInUrl');
        this.dashboardUrl = config.select('auth.dashboardUrl');
        this.verifyUrl = config.select('auth.verifyUrl');
    }
    Object.defineProperty(TokenAuthService.prototype, "intendedUrl", {
        get: function () {
            return this.routingState.getPreviousUrl();
        },
        set: function (url) {
            if (url.includes('sign-in') || url.includes('sign-out')) {
                this._intendedUrl = this.config.select('auth.dashboard');
            }
            else {
                this._intendedUrl = url;
            }
        },
        enumerable: true,
        configurable: true
    });
    TokenAuthService.prototype.prevUrl = function () {
        return this.routingState.getPreviousUrl();
    };
    TokenAuthService.prototype.signIn = function (email, password) {
        var _this = this;
        return this.getToken(email, password).pipe(map(function (_a) {
            var token = _a.token;
            _this.local.set('token', token);
            return !!token;
        }));
    };
    TokenAuthService.prototype.signOut = function () {
        var _this = this;
        return forkJoin([
            this.config.select('store.remote.urls.base'),
        ]).pipe(switchMap(function (_a) {
            var _b = __read(_a, 1), baseUrl = _b[0];
            return _this.remote.post(baseUrl + "/api/auth/revoke", {
                token: _this.local.get('token')
            });
        }), map(function (status) {
            _this.local.remove('token');
            return !(_this._user = null);
        }));
    };
    TokenAuthService.prototype.check = function () {
        var token = this.local.get('token');
        return of(!!token);
    };
    TokenAuthService.prototype.user = function () {
        var _this = this;
        return forkJoin([
            this.config.select('store.remote.urls.base'),
            of(this._user)
        ]).pipe(switchMap(function (_a) {
            var _b = __read(_a, 2), baseUrl = _b[0], user = _b[1];
            return (user) ? of(user) : _this.remote.get(baseUrl + "/api/auth/user").pipe(map(function (response) { return response && response['user'] && response['user']; }));
        }), map(function (user) {
            return _this._user = user;
        }));
    };
    TokenAuthService.prototype.token = function () {
        var token = this.local.get('token');
        return token ? "Bearer " + token : '';
    };
    TokenAuthService.prototype.getToken = function (email, password) {
        var _this = this;
        return forkJoin([
            this.config.select('store.remote.urls.base'),
            this.config.select('name'),
        ]).pipe(switchMap(function (_a) {
            var _b = __read(_a, 2), baseUrl = _b[0], device_name = _b[1];
            return _this.remote.post(baseUrl + "/api/auth/token", { email: email, password: password, device_name: device_name });
        }));
    };
    TokenAuthService.ctorParameters = function () { return [
        { type: HttpStoreContract },
        { type: KeyValueStoreContract },
        { type: ConfigContract },
        { type: RoutingStateContract }
    ]; };
    TokenAuthService.ɵprov = ɵɵdefineInjectable({ factory: function TokenAuthService_Factory() { return new TokenAuthService(ɵɵinject(HttpStoreContract), ɵɵinject(KeyValueStoreContract), ɵɵinject(ConfigContract), ɵɵinject(RoutingStateContract)); }, token: TokenAuthService, providedIn: "root" });
    TokenAuthService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], TokenAuthService);
    return TokenAuthService;
}());

/*
 * Public API Surface of ng-bedrock
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AuthContract, AuthGuard, AuthInterceptor, CONFIG_DATA, Config, ConfigContract, Delay, DirectivesModule, Emitter, EmitterContract, EntityStore, FILE_JSON_HEADER, HttpStoreContract, KeyValueStoreContract, LocalStore, Log, NORMAL_JSON_HEADER, NotifInterceptor, NotifyContract, PIPES, PRIVILEGE_ENTITIES_DATA, ParsePipe, PipesModule, PrivilegePipe, PrivilegeService, RemoteStore, ReplacePipe, RouterStoreModule, RouterStoreService, RoutingStateService, SQLStoreContract, ScriptLoaderService, SessionAuthService, SessionStore, StoreSyncInterceptor, Sync, Tick, TitleService, TokenAuthService, Track, TruncatePipe, UnauthGuard, Unsubscribe, WebStore, arrayGroupBy, camelCase, catchRxErrors, compare, copy, cut, deepCopy, hash, injector, isArray, isBlankString, isFunction, isNullOrUndefined, isNumeric, isObject, isObservable, isUndefined, keys, merge, mergeToArray, numberWithCommas, objectDeepMerge, objectGroupBy, outject, plural, randomString, routeGroupMatcher, setInjector, singular, snakeCase, time, titleCase, toJSON };
//# sourceMappingURL=xbucks-ng-bedrock.js.map
