import { Observable } from 'rxjs';
import { JSONContract, HttpStoreContract, SQLStoreContract, ConfigContract, NotifyContract } from '../contracts';
import { RemoteStore } from './remote-store.service';
import { HttpClient } from '@angular/common/http';
export declare class EntityStore<M = JSONContract> extends RemoteStore implements HttpStoreContract, SQLStoreContract {
    private config;
    entityName: string;
    constructor(agent: HttpClient, notif: NotifyContract, config: ConfigContract);
    entity(name: string): this;
    create(payload: M): Observable<M>;
    retrieveOne(id: string): Observable<M>;
    retrieveMany(filter: JSONContract): Observable<M[]>;
    update(id: string, payload: Partial<M>): Observable<M>;
    remove(id: string): Observable<M>;
}
