import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { NotifyContract, HttpOptions, HttpStoreContract, JSONContract } from '../contracts';
export declare const NORMAL_JSON_HEADER: {
    'Content-Type': string;
    Accept: string;
};
export declare const FILE_JSON_HEADER: {};
export declare class RemoteStore implements HttpStoreContract {
    private agent;
    private notif;
    constructor(agent: HttpClient, notif: NotifyContract);
    aRequest<M = JSONContract>(method: string, url: string, payload?: Object, moreOptions?: HttpOptions, isFile?: boolean): Observable<M>;
    get<M = JSONContract>(url: string): Observable<M>;
    post<M = JSONContract>(url: string, payload: Object): Observable<M>;
    put<M = JSONContract>(url: string, payload: Object): Observable<M>;
    delete<M = JSONContract>(url: string): Observable<M>;
    patch<M = JSONContract>(url: string, payload: Object, moreOptions?: HttpOptions): Observable<M>;
}
