import { Observable } from 'rxjs';
import { KeyValueStoreContract, HttpStoreContract, ConfigContract, JSONContract, AuthContract } from '../contracts';
import { RoutingStateContract } from '../contracts/routing-state.contract';
export declare class SessionAuthService implements AuthContract {
    private remote;
    private local;
    private routingState;
    private config;
    _intendedUrl: string;
    signInUrl: string;
    dashboardUrl: string;
    verifyUrl: string;
    _user: JSONContract;
    constructor(remote: HttpStoreContract, local: KeyValueStoreContract, routingState: RoutingStateContract, config: ConfigContract);
    get intendedUrl(): string;
    prevUrl(): string;
    csrf(): Observable<JSONContract>;
    signIn(email: string, password: string): Observable<boolean>;
    signOut(): Observable<boolean>;
    check(): Observable<boolean>;
    user(): Observable<JSONContract>;
}
