import { Observable } from 'rxjs';
import { AuthContract, UserContract, HttpStoreContract, ConfigContract, KeyValueStoreContract, JSONContract } from '../contracts';
import { RoutingStateContract } from '../contracts/routing-state.contract';
export declare class TokenAuthService implements AuthContract {
    private remote;
    private local;
    private config;
    private routingState;
    _intendedUrl: string;
    signInUrl: string;
    dashboardUrl: string;
    verifyUrl: string;
    _user: UserContract;
    set intendedUrl(url: string);
    get intendedUrl(): string;
    constructor(remote: HttpStoreContract, local: KeyValueStoreContract, config: ConfigContract, routingState: RoutingStateContract);
    prevUrl(): string;
    signIn(email: string, password: string): Observable<boolean>;
    signOut(): Observable<boolean>;
    check(): Observable<boolean>;
    user(): Observable<JSONContract>;
    token(): string;
    getToken(email: string, password: string): Observable<JSONContract>;
}
